"use strict";
/**
 * A script to distribute bounty tokens to people who donated to a sol wallet
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const spl_token_1 = require("@solana/spl-token");
const web3_js_1 = require("@solana/web3.js");
const spl_utils_1 = require("@strata-foundation/spl-utils");
const serviceAccount = web3_js_1.Keypair.fromSecretKey(Buffer.from(JSON.parse(require("fs").readFileSync(process.env.ANCHOR_WALLET, {
    encoding: "utf-8",
}))));
const truthy = (value) => !!value;
function run() {
    return __awaiter(this, void 0, void 0, function* () {
        const address = new web3_js_1.PublicKey("FqgDG5xfGiMktv5MB7BCfD63gVYeRjbsmwn3oGZBmF9t");
        const mint = new web3_js_1.PublicKey("AUcAKtWtxoc4vbrvzP4MXZBcVFKdtFsm7NjCUpkmsWWX");
        const connection = new web3_js_1.Connection(process.env.SOLANA_URL);
        const signatures = yield connection.getSignaturesForAddress(address, {
            limit: 1000,
        });
        console.log(signatures.length);
        const txns = (yield Promise.all(signatures.map((sig) => connection.getTransaction(sig.signature))))
            .map((tx, index) => {
            var _a, _b, _c;
            if ((((_c = (_b = (_a = tx === null || tx === void 0 ? void 0 : tx.transaction) === null || _a === void 0 ? void 0 : _a.message) === null || _b === void 0 ? void 0 : _b.accountKeys) === null || _c === void 0 ? void 0 : _c.length) || 0) > 3) {
                console.log("Invalid tx", signatures[index].signature);
                return;
            }
            return tx;
        })
            .filter(truthy)
            .filter((t) => { var _a; return !((_a = t.meta) === null || _a === void 0 ? void 0 : _a.err); });
        const amounts = txns
            .map((tx, index) => {
            if (tx.meta) {
                const accounts = tx.transaction.message.accountKeys;
                return tx.meta.preBalances.reduce((acc, balance, index) => {
                    acc.set(accounts[index].toBase58(), {
                        preBalance: balance,
                        postBalance: tx.meta.postBalances[index],
                    });
                    return acc;
                }, new Map());
            }
        })
            .filter(truthy);
        const totalsByWallet = amounts.map((a) => {
            const balances = a.get(address.toBase58());
            const amount = balances.postBalance - balances.preBalance;
            if (amount > 0) {
                a.delete(address.toBase58());
                a.delete("11111111111111111111111111111111");
                const myKey = [...a.keys()][0];
                console.log(`Key ${myKey}, Amount ${amount / Math.pow(10, 9)}`);
                return { wallet: myKey, amount };
            }
        }).filter(truthy);
        const myAta = yield spl_token_1.Token.getAssociatedTokenAddress(spl_token_1.ASSOCIATED_TOKEN_PROGRAM_ID, spl_token_1.TOKEN_PROGRAM_ID, mint, serviceAccount.publicKey, false);
        for (const { wallet, amount } of totalsByWallet) {
            const owner = new web3_js_1.PublicKey(wallet);
            const destination = yield spl_token_1.Token.getAssociatedTokenAddress(spl_token_1.ASSOCIATED_TOKEN_PROGRAM_ID, spl_token_1.TOKEN_PROGRAM_ID, mint, owner, false);
            const instructions = [];
            if (!(yield connection.getAccountInfo(destination))) {
                instructions.push(spl_token_1.Token.createAssociatedTokenAccountInstruction(spl_token_1.ASSOCIATED_TOKEN_PROGRAM_ID, spl_token_1.TOKEN_PROGRAM_ID, mint, destination, owner, serviceAccount.publicKey));
            }
            instructions.push(spl_token_1.Token.createTransferInstruction(spl_token_1.TOKEN_PROGRAM_ID, myAta, destination, serviceAccount.publicKey, [], new spl_token_1.u64(amount)));
            console.log(`Sending ${amount / Math.pow(10, 9)} tokens to ${owner.toBase58()}`);
            const tx = new web3_js_1.Transaction({
                feePayer: serviceAccount.publicKey,
                recentBlockhash: (yield connection.getRecentBlockhash()).blockhash,
            });
            tx.add(...instructions);
            tx.sign(serviceAccount);
            yield (0, spl_utils_1.sendAndConfirmWithRetry)(connection, tx.serialize(), {
                skipPreflight: true
            }, "confirmed");
        }
    });
}
run().catch((e) => {
    console.error(e);
    process.exit(1);
});
//# sourceMappingURL=bounty-dist.js.map